SWEP.Author = "Soyez"
SWEP.Contact = ""
SWEP.Purpose = "Magneto"

SWEP.Category = "Heroes"
SWEP.Instructions = "Primary to bring stuff!/Secondary to shoot all!"

SWEP.Spawnable = false
SWEP.AdminSpawnable = false

SWEP.ViewModel = "models/weapons/v_physcannon.mdl"
SWEP.WorldModel = "models/weapons/w_physics.mdl"

SWEP.Primary.ClipSize = -1
SWEP.Primary.DefaultClip = -1
SWEP.Primary.Automatic = false
SWEP.Primary.Ammo = "none"
 
SWEP.Secondary.ClipSize = -1
SWEP.Secondary.DefaultClip = -1
SWEP.Secondary.Automatic = false
SWEP.Secondary.Ammo = "none"

local PrimarySound     = Sound( "weapons/physcannon/energy_disintegrate5.wav" )
local SecondarySound   = Sound( "weapons/physgun_off.wav" )

function SWEP:Reload()
end

function SWEP:Think()
	if SERVER then
		if self.Owner:KeyDown( IN_ATTACK2 ) then
			local Targets = FindInView( self.Owner, 1500 )
			for _, ent in pairs( Targets ) do
				if ent:IsValid() && !ent:IsPlayer() && !ent:IsNPC() then
					
					entphys   = ent:GetPhysicsObject()

					if entphys:IsValid() then

						pos1 = self.Owner:GetPos() + ( self.Owner:GetAimVector() * 256 ) + Vector( 0, 0, 70 )
						local pos2 = entphys:GetPos()
						local vec  = ( pos1 - pos2 ):Normalize()
						local dist = pos1:Distance(pos2)
						entphys:ApplyForceCenter(vec * 20 * entphys:GetMass() )
						if dist < 64 then
							entphys:SetVelocity( Vector(0,0,0) )
						end
						
						if( ent:GetPhysicsAttacker( 1 ) != self.Owner && ent:GetClass() != "prop_ragdoll" ) then
							ent:SetPhysicsAttacker( self.Owner, 1 )
						end
					end
				end
			end
		end
	elseif CLIENT then
		if self.Owner:KeyDown( IN_ATTACK2 ) then
			self.Weapon:EmitSound( SecondarySound )
			//TODO Add awesome effects!
		end
	end
end

function SWEP:PrimaryAttack()
	if SERVER then

		local Targets = FindInView( self.Owner, 1024 )
		for _, ent in pairs( Targets ) do
            if ent:IsValid() && !ent:IsPlayer() && !ent:IsNPC() then
				
				entphys   = ent:GetPhysicsObject()

				if entphys:IsValid() then
	
					pos1 = self.Owner:GetPos()
					pos2 = entphys:GetPos()
					vec  = ( pos2 - pos1 ):Normalize()
					
					entphys:ApplyForceCenter( vec * 15000 * entphys:GetMass() * 500 )

					if( ent:GetPhysicsAttacker( 1 ) != self.Owner && ent:GetClass() != "prop_ragdoll" ) then
						ent:SetPhysicsAttacker( self.Owner, 1 )
					end
				end
			end
		end
	elseif CLIENT then
		self.Weapon:EmitSound( PrimarySound )
		//TODO Add awesome effects!
	end
end

function SWEP:SecondaryAttack()
end

function FindInView( thisplayer, max_distance )

	local thisangle = thisplayer:GetAimVector():Angle()

	local thisyawmin = Angle(0,0,0)
	thisyawmin.Yaw = thisangle.Yaw - (thisplayer:GetFOV()/2)
	thisyawmin.Pitch = thisangle.Pitch
	thisyawmin.Roll = thisangle.Roll
	
	local thisyawmax = Angle(0,0,0)
	thisyawmax.Yaw = thisangle.Yaw + (thisplayer:GetFOV()/2)
	thisyawmax.Pitch = thisangle.Pitch
	thisyawmax.Roll = thisangle.Roll
	
	local ent_list = {}
	if (max_distance) then
		ent_list = ents.FindInSphere(thisplayer:GetPos(), max_distance)
	else
		ent_list = ents.FindByClass("*")
	end
	local results = {}

	local p1 = thisplayer:GetPos()
	for _, ent in pairs(ent_list) do

		if (thisplayer != ent) then
			local p2 = ent:GetPos()
			local pDir = p2 - p1
			local ang = pDir:Angle()

			local CS = (ang.Yaw >= thisyawmin.Yaw and ang.Yaw <= thisyawmax.Yaw)

			if (CS) then
				table.insert(results, ent)
			end
		end
	end

	return results
end