SWEP.Author			= "Soyez"
SWEP.Contact		= ""
SWEP.Purpose		= "Storm"
SWEP.Instructions	= "Left click to spawn a tornado, right click to remove a tornado"

SWEP.Spawnable			= false
SWEP.AdminSpawnable		= false

SWEP.ViewModel			= "models/weapons/v_physcannon.mdl"
SWEP.WorldModel			= "models/weapons/w_Physics.mdl"

SWEP.Primary.ClipSize		= -1
SWEP.Primary.DefaultClip	= -1
SWEP.Primary.Automatic		= false
SWEP.Primary.Ammo			= "none"

SWEP.Secondary.ClipSize		= -1
SWEP.Secondary.DefaultClip	= -1
SWEP.Secondary.Automatic	= false
SWEP.Secondary.Ammo			= "none"

SWEP.TornadoForce = 500000000
SWEP.TornadoRadius = 100000

SWEP.ShootSound = "ambient/energy/spark5.wav"
SWEP.ShootTornado = false
SWEP.SmokeCloud1 = false
SWEP.SmokeCloud2 = false
util.PrecacheSound("ambient/energy/spark5.wav")

function SWEP:PrimaryAttack()
	local tr = self.Owner:GetEyeTrace()
	if(self.SmokeCloud1 != false && self.SmokeCloud2 != false && !self.SmokeCloud1:IsValid() && !self.SmokeCloud2:IsValid()) then
		self.SmokeCloud1 = false
		self.SmokeCloud2 = false
		self.ShootTornado = false
	end
	if(self.ShootTornado == true) then return end
	self.Weapon:StopSound(self.ShootSound)
	self.Weapon:EmitSound(self.ShootSound)
	self.BaseClass.ShootEffects(self)	
	self.ShootTornado = true
	
	if(!SERVER) then return end
	self:MakeTornado(tr.HitPos)
end

function SWEP:MakeTornado(SpawnPos)	
	local BeamStart = ents.Create("info_target")
	BeamStart:SetPos(SpawnPos)
	BeamStart:SetKeyValue("targetname", "BeamStart")
	BeamStart:Spawn()
	BeamStart:Fire("kill", "", 0.3)
	
	local BeamEnd = ents.Create("info_target")
	BeamEnd:SetPos(SpawnPos + Vector(0, 0, 10000))
	BeamEnd:SetKeyValue("targetname", "BeamEnd")
	BeamEnd:Spawn()
	BeamEnd:Fire("kill", "", 0.3)
	
	local Beam = ents.Create("env_beam")
	Beam:SetKeyValue("targetname", "Beam")
	Beam:SetKeyValue("texture", "sprites/lgtning.vtf")
	Beam:SetKeyValue("renderamt", 255)
	Beam:SetKeyValue("rendercolor", "0 155 255")
	Beam:SetKeyValue("life", 0.25)
	Beam:SetKeyValue("LightningStart", "BeamStart")
	Beam:SetKeyValue("LightningEnd", "BeamEnd")
	Beam:SetKeyValue("TouchType", 0)
	Beam:SetKeyValue("framestart", 0)
	Beam:SetKeyValue("framerate", 0)
	Beam:SetKeyValue("NoiseAmplitude", 0)
	Beam:SetKeyValue("TextureScroll", 35)
	Beam:SetKeyValue("BoltWidth", 25)
	Beam:SetKeyValue("Radius", 256)
	Beam:SetPos(SpawnPos)
	Beam:Spawn()
	Beam:Fire("TurnOn", "", 0.01)
	Beam:Fire("kill", "", 1)
	
	SmokeCloud1 = ents.Create("env_smokestack")
	SmokeCloud1:SetKeyValue("BaseSpread", "300")
	SmokeCloud1:SetKeyValue("SpreadSpeed", "2000")
	SmokeCloud1:SetKeyValue("Speed", "2000")
	SmokeCloud1:SetKeyValue("StartSize", "400")
	SmokeCloud1:SetKeyValue("EndSize", "500")
	SmokeCloud1:SetKeyValue("Rate", "100")
	SmokeCloud1:SetKeyValue("JetLength", "10000")
	SmokeCloud1:SetKeyValue("twist", "900")
	SmokeCloud1:SetKeyValue("SmokeMaterial", "particle/SmokeStack.vmt")
	SmokeCloud1:SetKeyValue("renderamt", "100")
	SmokeCloud1:Spawn()
	SmokeCloud1:SetPos(SpawnPos)
	SmokeCloud1:Fire("turnon", "", 0.01)
	SmokeCloud1:Fire("kill", "", 20)
	self.SmokeCloud1 = SmokeCloud1
	
	SmokeCloud2 = ents.Create("env_smokestack")
	SmokeCloud2:SetKeyValue("BaseSpread", "2000")
	SmokeCloud2:SetKeyValue("SpreadSpeed", "50")
	SmokeCloud2:SetKeyValue("Speed", "1000")
	SmokeCloud2:SetKeyValue("StartSize", "2000")
	SmokeCloud2:SetKeyValue("EndSize", "3000")
	SmokeCloud2:SetKeyValue("Rate", "20")
	SmokeCloud2:SetKeyValue("JetLength", "1000")
	SmokeCloud2:SetKeyValue("twist", "500")
	SmokeCloud2:SetKeyValue("SmokeMaterial", "particle/SmokeStack.vmt")
	SmokeCloud2:SetKeyValue("renderamt", "50")
	SmokeCloud2:Spawn()
	SmokeCloud2:SetPos(SpawnPos + Vector(0, 0, 5000))
	SmokeCloud2:Fire("turnon", "", 1)
	SmokeCloud2:Fire("kill", "", 21)
	self.SmokeCloud2 = SmokeCloud2
end

function SWEP:SecondaryAttack()
	if(self.ShootTornado == false || self.SmokeCloud1 == false || self.SmokeCloud2 == false || !self.SmokeCloud1:IsValid() || !self.SmokeCloud2:IsValid()) then return end
	self.Weapon:StopSound(self.ShootSound)
	self.Weapon:EmitSound(self.ShootSound)
	self.BaseClass.ShootEffects(self)	
	self.ShootTornado = false
	
	if(!SERVER) then return end
	self.SmokeCloud1:Remove()
	self.SmokeCloud2:Remove()
	self.SmokeCloud1 = false
	self.SmokeCloud2 = false
end

--Thanks at feihc for the base!
function SWEP:PointGrav(Center, Radius, Force)
    local GravitySphere = ents.FindInSphere(Center, Radius)
    for k, v in pairs(GravitySphere) do
        if(v:IsValid() && !v:IsWorld()) then
	        local vPos = v:GetPos()
			local Mass = 1
			
			local PhysCheck = false
			local PhysObj = v:GetPhysicsObject()
			if(PhysObj:IsValid()) then
				PhysCheck = true
				Mass = PhysObj:GetMass()
			end
			
			local Calc1 = (Force * Mass) / (((Center - vPos):Length() - 64) ^ 2)
			local Calc2 = (Center - vPos):Normalize()
			local Calc3 = Calc1 * Calc2
			
			if(PhysCheck == true) then
				if(v:GetClass() == "prop_vehicle_jeep") then
					local objects = v:GetPhysicsObjectCount()
					for i=0, objects-1 do
						local PhysObj2 = v:GetPhysicsObjectNum(i)
						PhysObj2:ApplyForceCenter(Calc3)
					end
				else
					PhysObj:ApplyForceCenter(Calc3)
				end
			else
				v:SetVelocity(Calc3 / 5000)
			end
        end
    end
end

function SWEP:Think()
	if(self.ShootTornado == false || self.SmokeCloud1 == false || self.SmokeCloud2 == false || !self.SmokeCloud1:IsValid() || !self.SmokeCloud2:IsValid()) then return end
	self:PointGrav(SmokeCloud2:GetPos(), self.TornadoRadius, self.TornadoForce)
end

function SWEP:Holster()
	self:SecondaryAttack()
	self.Weapon:StopSound(self.ShootSound)
	return true
end 
   
function SWEP:Reload()
end
