if SERVER then
	AddCSLuaFile( "shared.lua" )
	SWEP.Weight			= 5
	SWEP.AutoSwitchTo		= false
	SWEP.AutoSwitchFrom		= false
end

if CLIENT then
	SWEP.DrawAmmo			= true
	SWEP.Slot			= 1
	SWEP.SlotPos			= 4	
	SWEP.DrawCrosshair		= true
	SWEP.ViewModelFOV		= 82
	SWEP.ViewModelFlip		= true
	SWEP.PrintName			= "Lightning"

	surface.CreateFont( "csd", ScreenScale( 30 ), 500, true, true, "CSKillIcons" )
	surface.CreateFont( "csd", ScreenScale( 60 ), 500, true, true, "CSSelectIcons" )
end


SWEP.Author			= "Soyez"
SWEP.Contact			= ""
SWEP.Purpose			= "Kill things"
SWEP.Instructions		= "Primary: Lightning Bolt\nSecondary: Gathered Bolt / Call Lightning\nReload: Charge Mana"

SWEP.ViewModel			= ""
SWEP.WorldModel			= "models/weapons/w_crowbar.mdl"

SWEP.Spawnable			= false
SWEP.AdminSpawnable		= false

SWEP.Primary.Sound		= Sound( "Weapon_AK47.Single" )
SWEP.Primary.Recoil		= 1.5
SWEP.Primary.Damage		= 40
SWEP.Primary.NumShots		= 1
SWEP.Primary.Cone		= 0.02
SWEP.Primary.Delay		= 0.15

SWEP.Primary.ClipSize		= 0
SWEP.Primary.DefaultClip	= 100
SWEP.Primary.Automatic		= true
SWEP.Primary.Ammo		= "CombineCannon"

SWEP.Secondary.ClipSize		= -1
SWEP.Secondary.DefaultClip	= -1
SWEP.Secondary.Automatic	= false
SWEP.Secondary.Ammo		= "none"
SWEP.Secondary.Delay		= 2

SWEP.Mana 			= 100
SWEP.Distance 			= 500 * 12

SWEP.Sounds = {
	Thunder = {
		Sound( "ambient/atmosphere/thunder4.wav" ),
		Sound( "ambient/weather/thunder3.wav"    ),
		Sound( "ambient/atmosphere/thunder1.wav" ),
		Sound( "ambient/weather/thunder4.wav"    ),
		Sound( "ambient/weather/thunder2.wav"    ),
		Sound( "ambient/weather/thunder6.wav"    ),
		Sound( "ambient/weather/thunder5.wav"    ),
		Sound( "ambient/atmosphere/thunder2.wav" ),
		Sound( "ambient/atmosphere/thunder3.wav" ),
		Sound( "ambient/weather/thunder1.wav"    )
		},
	Explosion = {
		Sound( "ambient/explosions/explode_6.wav" ),
		Sound( "ambient/explosions/explode_3.wav" ),
		Sound( "ambient/explosions/explode_1.wav" ),
		Sound( "ambient/explosions/explode_7.wav" ),
		Sound( "ambient/explosions/explode_5.wav" ),
		Sound( "ambient/explosions/explode_4.wav" ),
		Sound( "ambient/explosions/explode_2.wav" ),
		Sound( "ambient/explosions/explode_9.wav" ),
		Sound( "ambient/explosions/explode_8.wav" )
		}
}

SWEP.NumSounds = {
	Thunder = #SWEP.Sounds.Thunder,
	Explosion = #SWEP.Sounds.Explosion
		}


function SWEP:Bolt( )
	if SERVER then
		if self.Mana < 10 then
			return
		end
	end

	local res, start, ende

	start = self.Owner:GetShootPos( )
	ende = start + self.Distance * self.Owner:GetAimVector( )

	res = util.TraceLine{ start = start, endpos = ende, filter = self.Owner, mask = MASK_SHOT }

	if res.Entity and res.Entity:IsValid( ) and SERVER then
		res.Entity:TakeDamage( math.random( 70, 200 ), self.Owner, self )
	end

	if SERVER then
		util.BlastDamage( self, self.Owner, res.HitPos, 300, math.random( 70, 200 ) )
		self.Mana = self.Mana - 10

		self:EmitSoundX( "Thunder", ende, 150 )
		self:EmitSoundX( "Explosion", res.HitPos, 100 )
	end

	self:DispEffect( "bolt", { Origin = start, Normal = self.Owner:GetAimVector( ), Start = res.HitPos, Scale = 240, Radius = 12 } )
	self:DispEffect( "ThumperDust", { Origin = res.HitPos, Start = res.HitPos, Normal = res.HitNormal, Scale = 500, Radius = 45, Angle = res.HitNormal:Angle( ) } )
end

function SWEP:DispEffect( name, data )
	local data2, k, v

	data2 = EffectData( )
		for k, v in pairs( data ) do
			data2[ "Set" .. k ]( data2, v )
		end
	util.Effect( name, data2 )
end

function SWEP:EmitSoundX( tbl, pos, vol, pitch )
	vol = vol or 75
	pitch = pitch or 100

	WorldSound( self.Sounds[ tbl ][ math.random( self.NumSounds[ tbl ] ) ], pos, vol, pitch )
end

function SWEP:BoltX( a, b )
	local res, start, ende, norm

	start = a
	ende = b

	res = util.TraceLine{ start = start, endpos = ende, filter = self.Owner }

	if res.Entity and res.Entity:IsValid( ) and SERVER then
		res.Entity:TakeDamage( math.random( 70, 200 ), self.Owner, self )
	end

	if SERVER then
		util.BlastDamage( self, self.Owner, res.HitPos, 300, math.random( 70, 200 ) )
		self:EmitSoundX( "Thunder", ende, 150 )
		self:EmitSoundX( "Explosion", res.HitPos, 100 )
	end

	self:DispEffect( "bolt", { Origin = start, Normal = ( b - a ):Normalize( ), Start = res.HitPos, Scale = 240, Radius = 12 } )
	self:DispEffect( "ThumperDust", { Origin = b, Start = res.HitPos, Normal = res.HitNormal, Scale = 500, Radius = 45, Angle = res.HitNormal:Angle( ) } )
end

function SWEP:Charge( )
	if SERVER then
		self.Owner:Freeze( true )

		timer.Create( "recharge", .01, 500, function( ) if self.Owner:IsValid( ) then self.Mana = self.Mana + 1 end end )
		timer.Simple( 5, self.Owner.Freeze, self.Owner, false )
	end

	self:DispEffect( "charge", { Start = self.Owner:GetPos( ), Scale = 32, Radius = 20 } )
end

function SWEP:HandleBlast( a )
	local res

	res = util.TraceLine{ start = a, endpos = a - Vector( 0, 0, self.Distance ) }

	timer.Create( "CallLightning", .25, 60, function( )
				local adder
				if self.Owner and self.Owner:IsValid( ) then
					adder = Vector( ( math.random( ) * 2 - 1 ) * 512, ( math.random( ) * 2 - 1 ) * 512, 0 )
					self:BoltX( a + adder, res.HitPos + adder )
				end
						end )
end

function SWEP:BlastMarker( )
	local start, ende, res, data, res2

	start = self.Owner:GetShootPos( )
	ende = self.Distance * self.Owner:GetAimVector( )
	
	res = util.TraceLine( { start = start, endpos = ende, filter = self.OWner } )

	if not res.HitWorld then return end

	if SERVER then
		if self.Mana < 1000 then return end
		self.Mana = self.Mana - 1000
	end

	if self:Clip1( ) < 1000 then return end
		
	res2 = util.TraceLine{ start = res.HitPos, endpos = res.HitPos + Vector( 0, 0, 1 ) * self.Distance }

	self:DispEffect( "charge", { Start = res.HitPos, Scale = 412, Radius = 20 } )

	if SERVER then
		timer.Simple( 5, function( ) self:HandleBlast( res2.HitPos ) end )
	end
end

function SWEP:Initialize()
	if SERVER then
		self:SetWeaponHoldType( "pistol" )
	end
end

function SWEP:Think( )
	if SERVER then 
		self:SetClip1( self.Mana )
		self:SetNWFloat( "NextCast", self.NextCast or 0 )

		if self.Mana > 5000 then
			self.Owner:TakeDamage( 1, self.Owner, self )
		end
	end
end

function SWEP:Reload()
	self.NextCast = self.NextCast or CurTime( )

	if self.NextCast <= CurTime( ) then
		self.NextCast = CurTime( ) + 5
		self:Charge( )
	end
end

function SWEP:PrimaryAttack()
	self.NextCast = self.NextCast or CurTime( )

	if self.NextCast <= CurTime( ) then
		self.NextCast = CurTime( ) + 1.3
		self:Bolt( )
	end
end

function SWEP:SecondaryAttack()
	self.NextCast = self.NextCast or CurTime( )

	if self.NextCast <= CurTime( ) then
		self.NextCast = CurTime( ) + 5
		self:BlastMarker( )
	end
end

function SWEP:Deploy( )
	if SERVER then self.Owner:DrawWorldModel( false ) end
	return true
end

function SWEP:Holster( )
	if SERVER then self.Owner:DrawWorldModel( true ) end
	return true
end

function SWEP:DrawHUD( )
	self.Color = self.Color or Color( 189, 189, 000, 255 )
	
	draw.WordBox( 1, 0, surface.ScreenHeight( ) * .5, "Time left until next Tunder: " .. math.ceil( math.max( self:GetNWFloat( "NextCast", 0 ) - CurTime( ), 0 ) ), "TargetID", Color( 000, 000, 000, 170 ), self.Color )
end